#!/usr/bin/env python
import sys
import commands
try:
  import hashlib
  md5_constructor = hashlib.md5
except ImportError:
  import md5
  md5_constructor = md5.new

import commands,re,string,sys,os
import datetime
import sys
import struct
from socket import AF_INET, SOCK_DGRAM, socket

# Folder on mac where to backup to

backup_on_mac1 = '/Users/yishen/backup/home'
backup_on_mac2 = '/Users/yishen/backup/web'


# List of folders (on the sever) to backup
folders1=['~/']  # Your home directory on vostok
folders2=['/web/html/data/media/public/sep/yishen'] # Your website on zapad



## Get time and date as string
C=str(datetime.date.today().isoformat())




GROWL_UDP_PORT=9887
GROWL_PROTOCOL_VERSION=1
GROWL_TYPE_REGISTRATION=0
GROWL_TYPE_NOTIFICATION=1

class GrowlRegistrationPacket:
  """Builds a Growl Network Registration packet.
     Defaults to emulating the command-line growlnotify utility."""

  def __init__(self, application="growlnotify", password = None ):
    self.notifications = []
    self.defaults = [] # array of indexes into notifications
    self.application = application.encode("utf-8")
    self.password = password
  # end def


  def addNotification(self, notification="Command-Line Growl Notification", enabled=True):
    """Adds a notification type and sets whether it is enabled on the GUI"""
    self.notifications.append(notification)
    if enabled:
      self.defaults.append(len(self.notifications)-1)
  # end def


  def payload(self):
    """Returns the packet payload."""
    self.data = struct.pack( "!BBH",
                             GROWL_PROTOCOL_VERSION,
                             GROWL_TYPE_REGISTRATION,
                             len(self.application) )
    self.data += struct.pack( "BB",
                              len(self.notifications),
                              len(self.defaults) )
    self.data += self.application
    for notification in self.notifications:
      encoded = notification.encode("utf-8")
      self.data += struct.pack("!H", len(encoded))
      self.data += encoded
    for default in self.defaults:
      self.data += struct.pack("B", default)
    self.checksum = md5_constructor()
    self.checksum.update(self.data)
    if self.password:
       self.checksum.update(self.password)
    self.data += self.checksum.digest()
    return self.data
  # end def
# end class


class GrowlNotificationPacket:
  """Builds a Growl Network Notification packet.
     Defaults to emulating the command-line growlnotify utility."""

  def __init__(self, application="growlnotify",
               notification="Command-Line Growl Notification", title="Title",
               description="Description", priority = 0, sticky = False, password = None ):
    self.application  = application.encode("utf-8")
    self.notification = notification.encode("utf-8")
    self.title        = title.encode("utf-8")
    self.description  = description.encode("utf-8")
    flags = (priority & 0x07) * 2
    if priority < 0:
      flags |= 0x08
    if sticky:
      flags = flags | 0x0100
    self.data = struct.pack( "!BBHHHHH",
                             GROWL_PROTOCOL_VERSION,
                             GROWL_TYPE_NOTIFICATION,
                             flags,
                             len(self.notification),
                             len(self.title),
                             len(self.description),
                             len(self.application) )
    self.data += self.notification
    self.data += self.title
    self.data += self.description
    self.data += self.application
    self.checksum = md5_constructor()
    self.checksum.update(self.data)
    if password:
       self.checksum.update(password)
    self.data += self.checksum.digest()
  # end def

  def payload(self):
    """Returns the packet payload."""
    return self.data
  # end def
# end class


def growlNotify(title = "Script Finished", message = "",first="no"):
    
    addr = ("127.0.0.1", GROWL_UDP_PORT)
    s = socket(AF_INET,SOCK_DGRAM)
     
    if first=="yes":
      print "testit"
      p = GrowlRegistrationPacket(application="Network Demo", password="???")
      p.addNotification("Script Finished", enabled=True)
      s.sendto(p.payload(), addr)

    if not message:
        message = "Boo"

    print "test me %s"%message
    p = GrowlNotificationPacket(application="Network Demo",
        notification="Script Finished", title=title,
        description=message, priority=1,
        sticky=True, password="???")
    s.sendto(p.payload(),addr)
    s.close()


## Get time and date as string
C=str(datetime.date.today().isoformat())

if len(sys.argv)>1:
  if sys.argv[1]=="test":
    print "testing"
    growlNotify("Backup script","set up",first="yes")
    sys.exit(0);

message="Backup results for %s"%C
fail=0
for folder in folders1:
        cmd = "rsync -bHlpogtrve  >& "+ backup_on_mac1 +"/rsync.log ssh vostok:" + folder + " " + backup_on_mac1
        stat,out=commands.getstatusoutput(cmd)
        if stat!=0:
          message+="\n%s\n"%out
          fail=1
        else:
          message+="\nBackup succeeded for %s\n"%folder


for folder in folders2:
        cmd = "rsync -bHlpogtrve  >& "+ backup_on_mac2 +"/rsync.log ssh zapad:" + folder + " " + backup_on_mac2
        stat,out=commands.getstatusoutput(cmd)
        if stat!=0:
          message+="\n%s\n"%out
          fail=1

        else:
          message+="\nBackup succeeded for %s\n"%folder



print "message%s\n"%message
if fail==1:
  growlNotify("Backup result:","Finished. But some files are failed (look at ./rsync.log)")
else:
   growlNotify("Backup","Succeeded at %s"%C)
